package com.sztzjy.money_management.controller;

import com.sztzjy.money_management.annotation.AnonymousAccess;
import com.sztzjy.money_management.entity.KnowledgePoint;
import com.sztzjy.money_management.entity.KnowledgePointExample;
import com.sztzjy.money_management.mapper.KnowledgePointMapper;
import com.sztzjy.money_management.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@Api(tags = "知识点相关接口")
@RequestMapping("api/knowledgePoint")
public class KnowledgePointController {
    @Autowired
    KnowledgePointMapper knowledgePointMapper;

    @PostMapping("/insertKnowledgePoint")
    @ApiOperation("知识点新增/编辑")
    @AnonymousAccess
    private ResultEntity<HttpStatus> insertKnowledgePoint(@RequestBody KnowledgePoint knowledgePoint) {
        String knowledgePointName = knowledgePoint.getKnowledgePointName();
        KnowledgePointExample pointExample = new KnowledgePointExample();
        pointExample.createCriteria().andKnowledgePointNameEqualTo(knowledgePointName);
        List<KnowledgePoint> knowledgePoints = knowledgePointMapper.selectByExample(pointExample);
        if(knowledgePoints.isEmpty()){
            int insert = knowledgePointMapper.insert(knowledgePoint);
            if (insert==1){
                return new ResultEntity<HttpStatus>(HttpStatus.OK, "新增成功！");
            }else {
                return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, "新增失败！");
            }
        }else {
            int i = knowledgePointMapper.updateByPrimaryKey(knowledgePoint);
            if (i==1){
                return new ResultEntity<HttpStatus>(HttpStatus.OK, "编辑成功！");
            }else {
                return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, "编辑失败！");
            }
        }

    }


    @PostMapping("/getKnowledgePoint")
    @ApiOperation("知识点展示")
    @AnonymousAccess
    private ResultEntity<KnowledgePoint> getKnowledgePoint(@RequestParam String knowledgePointName) {
        KnowledgePoint knowledgePoint = knowledgePointMapper.selectByPrimaryKey(knowledgePointName);
        return new ResultEntity<>(knowledgePoint);
    }

    @PostMapping("/getKnowledgePointMulu")
    @ApiOperation("知识点左侧栏展示")
    @AnonymousAccess
    private ResultEntity<List<String>> getKnowledgePointMulu() {
        KnowledgePointExample knowledgePointExample = new KnowledgePointExample();
        List<String> nameList = knowledgePointMapper.selectNameList();
        return new ResultEntity<>(nameList);
    }
}
