package com.sztzjy.money_management.util.excel;

import cn.hutool.poi.excel.ExcelUtil;
import cn.hutool.poi.excel.ExcelWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.Assert;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.Arrays;

public class ExcelProvider {

    private static Logger logger = LoggerFactory.getLogger(ExcelProvider.class);

    /**
     * 简单通用excel导出 若需要复杂表头和更多样式等、需定义导出模板
     * 输出无样式的excel
     *
     * @param data 待导出的数据
     */
    public static void SimpleExcelExport(ExcelData data, OutputStream out){
        Assert.notNull(data, "无可导出的数据");
        Assert.notEmpty(data.getContents(), "无可导出的数据");
        ExcelWriter bigWriter = ExcelUtil.getBigWriter();
        bigWriter.write(data.getContents());
        bigWriter.flush(out,true);
    }

    public static void main(String[] args) throws Exception {
        ExcelData excelData = ExcelData.create(Arrays.asList("t1","t2"))
                .addRow(Arrays.asList("11","12"))
                .addRow(Arrays.asList("21","22"));
        FileOutputStream fileOut = new FileOutputStream("D:/111.xlsx");
        ExcelProvider.SimpleExcelExport(excelData,fileOut);
        fileOut.close();
    }
}
